=== debian/changelog ===
neovim (0.6.1-3) unstable; urgency=medium

  * Use 45 minute test timeout for all architectures

 -- James McCoy <jamessan@debian.org>  Sun, 02 Jan 2022 20:17:58 -0500

neovim (0.6.1-2) unstable; urgency=medium

  * rules: Skip flaky memory_usage functionaltest on armhf

 -- James McCoy <jamessan@debian.org>  Sat, 01 Jan 2022 16:26:58 -0500

neovim (0.6.1-1) unstable; urgency=medium

  * New upstream release
  * Remove backported patches
  * rules: Extend test timeout to 45 minutes on slower architectures

 -- James McCoy <jamessan@debian.org>  Fri, 31 Dec 2021 15:34:26 -0500

neovim (0.6.0-1) unstable; urgency=medium

  * New upstream release
    - Ignore sgmrp/sgmlp terminfo attributes for non-xterm compatible
      terminals which advertise TERM=xterm  (Closes: #999777)
    - Changed defaults:
      + 'hidden' is enabled
      + 'joinspaces' is disabled
      + 'switchbuf' defaults to "uselast"
      + 'viewoptions' includes "unix,slash", excludes "options"
    - Some mappings and autocmds are defined by default, but can be overridden
      by the user.  See ":help default-mappings" and ":help default-autocmds",
      respectively.
  * d/control: Bump minimum CMake to 3.10
  * d/control: Remove lua-mpack from Build-Depends since it is now vendored
  * Remove lintian override for file, rgb.txt, removed upstream
  * Declare compliance with Policy 4.6.0, no changes needed
  * Add <!nocheck> restriction to locales Build-Depends
  * Use standard salsa-ci pipeline for CI

 -- James McCoy <jamessan@debian.org>  Fri, 17 Dec 2021 13:42:07 -0500

neovim (0.5.1-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream release
  * Backport patch to fix lsp_spec test failure

 -- James McCoy <jamessan@debian.org>  Mon, 04 Oct 2021 22:24:41 -0400

neovim (0.5.0-1) experimental; urgency=medium

  * New upstream release (Closes: #991155)
  * rules: Set correct CMAKE_BUILD_TYPE when DEB_BUILD_OPTIONS=noopt
  * Update debian/copyright
  * control: Add new dependency libtree-sitter-dev to Build-Depends
  * Adjust path for nvim.png install
  * d/copyright: Deduplicate overlapping glob patterns
  * Add lintian overrides for nvim's help files

 -- James McCoy <jamessan@debian.org>  Mon, 09 Aug 2021 23:32:04 -0400
